'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = composeMiddleware;

var _lodash = require('lodash.every');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.foreach');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.mapvalues');

var _lodash6 = _interopRequireDefault(_lodash5);

var _createMiddleware = require('./createMiddleware');

var _createMiddleware2 = _interopRequireDefault(_createMiddleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function composeMiddleware() {
  for (var _len = arguments.length, middlewares = Array(_len), _key = 0; _key < _len; _key++) {
    middlewares[_key] = arguments[_key];
  }

  if (middlewares.length === 0) return function (store) {
    return function (dispatch) {
      return dispatch;
    };
  };
  if (middlewares.length === 1) return middlewares[0];

  if ((0, _lodash2.default)(middlewares, function (middleware) {
    return middleware.actionHandlers;
  })) {
    var _ret = function () {
      // regroup all the action handlers in the middlewares by action type.
      var actionHandlers = {};
      middlewares.forEach(function (middleware) {
        (0, _lodash4.default)(middleware.actionHandlers, function (actionHandler, type) {
          (actionHandlers[type] || (actionHandlers[type] = [])).push(actionHandler);
        });
      });
      return {
        v: (0, _createMiddleware2.default)((0, _lodash6.default)(actionHandlers, function (typeHandlers) {
          return composeMiddleware.apply(undefined, (0, _toConsumableArray3.default)(typeHandlers));
        }))
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
  }
  return function (store) {
    return function (next) {
      return middlewares.reduceRight(function (next, handler) {
        return handler(store)(next);
      }, next);
    };
  };
}